library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity configcpld is
   port(
      FXCLK     : in std_logic;  
      FXCLK1    : out std_logic;  
      FXCLK2    : out std_logic;  
      FXCLK3    : out std_logic;  
      FXCLK4    : out std_logic;  

      IFCLK     : in std_logic;  
      IFCLK1    : out std_logic;  
      IFCLK2    : out std_logic;  
      IFCLK3    : out std_logic;  
      IFCLK4    : out std_logic;  

      TCK      : in std_logic;  
      TCK1     : out std_logic;  
      TCK2     : out std_logic;  
      TCK3     : out std_logic;  
      TCK4     : out std_logic;  

      CCLK      : in std_logic;  
      CCLK1     : out std_logic;  
      CCLK2     : out std_logic;  
      CCLK3     : out std_logic;  
      CCLK4     : out std_logic;  

      CS1       : in std_logic;  
      CS2       : in std_logic;  
      CS3       : in std_logic;  
      CS4       : in std_logic;  
   
      PROG_GPIF : in std_logic;

      CTL5      : in std_logic
   );
end configcpld;


architecture RTL of configcpld is

--signal declaration
signal cclk_w : std_logic;

begin
    cclk_w <= CTL5 when (PROG_GPIF = '0') else CCLK;
    CCLK1 <= cclk_w when (CS1 = '1') else '0';
    CCLK2 <= cclk_w when (CS2 = '1') else '0';
    CCLK3 <= cclk_w when (CS3 = '1') else '0';
    CCLK4 <= cclk_w when (CS4 = '1') else '0';
    
    IFCLK1 <= IFCLK;
    IFCLK2 <= IFCLK;
    IFCLK3 <= IFCLK;
    IFCLK4 <= IFCLK;

    FXCLK1 <= FXCLK;
    FXCLK2 <= FXCLK;
    FXCLK3 <= FXCLK;
    FXCLK4 <= FXCLK;

    TCK1 <= TCK;
    TCK2 <= TCK;
    TCK3 <= TCK;
    TCK4 <= TCK;

end RTL;

